%define majorversion 0
%define minorversion 53
# to make pre-relocate capable RPM versions (v2.4) work:
%define myprefix /usr/local

Summary: Jikes - a fast open source Java compiler
Name: jikes
Version: %{majorversion}.%{minorversion} 
Release: 1
Copyright: IBM Public License V 1.0
Group: Development/Languages
Url: http://www.ibm.com/research/jikes 
Packager: Henner Zeller <zeller@think.de>
Source: http://www.research.ibm.com/jikes/download/jikes-%{majorversion}%{minorversion}_tar.gz 
Buildroot: /var/tmp/jikes-buildroot

# remove for pre-relocate capable RPM versions
Prefix: %{myprefix}

# remove for older RPMs: they don't understand i18n
Summary(de): Jikes - ein schneller open source Java-Compiler

%description
Jikes is a Java compiler, written from scratch in C++, that translates Java
source files as defined in The Java Language Specification (Addison-Wesley, 
1996) and Inner Classes Specification (JavaSoft, Release 2/10/97) into 
the bytecoded instruction set and binary format defined in 
The Java Virtual Machine Specification (Addison-Wesley, 1996). 

The original version of Jikes was written by Philippe Charles and Dave Shields 
of the IBM T. J. Watson Research Center. 
Since the release of the source in early December 1998 they have continued 
work on the compiler as contributors. 

# remove for older RPMs (i18n)
%description -l de
Jikes ist eine vom Grund auf in C++ geschriebene Implementierung 
eines Java-Compilers, der Java Source Files nach der 
Java Language Specification (Addison-Wesley, 1996) sowie der 
Inner Classes Specification (JavaSoft, Release 2/10/97) in
Bytecode, definiert in The Java Virtual Machine Specification 
(Addison-Wesley, 1996), bersetzt.

Die ursprngliche Version von Jikes wurde von  Philippe Charles und
Dave Shields vom IBM T. J. Watson Research Center geschrieben. Seit der
Freigabe des Quellcodes Anfang Dezember 1998 tragen beide weiterhin 
ihre Arbeit zu dem Compiler bei.

%prep
%setup -q -n jikes
cd src
autoconf

%build
cd src
./configure --prefix=$RPM_BUILD_ROOT%{myprefix}
make

%install
cd src
make install
# do it 'by hand' until jikes provides it in the makefile
install -d $RPM_BUILD_ROOT%{myprefix}/man/man1
install jikes.1 $RPM_BUILD_ROOT%{myprefix}/man/man1

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc README.TXT contrib.htm jikes.htm license.htm
%doc %{myprefix}/man/man1/jikes.1
%{myprefix}/bin/jikes

